/*
 *	La classe gestisce lo smistamento delle richieste provenienti dagli<br>
 *	Utenti su due diverse servlet: ServletCatalogo e ServletOrdini.<br>
 *	Dati gli scopi puramente esplicativi di questo sorgente, vi sono diverse versioni<br>
 *	del metodo doGet() commentate, che contengono le diverse soluzioni prospettate<br>
 *	e le eccezioni che si sono volute sollevare.<br>
 *	Perch il codice funzioni correttamente  necessario creare un contesto "CD" nell'ambito<br>
 *	di un servlet container, come Tomcat(su cui il codice  stato testato) o Allaire JRun.<br>
 *  per compilare questo sorgente  consigliabile la versione 2.2 delle API servlet<br>
 *	o superiore<br>.
 *
 *	@author Giovanni Tommasi
 */ 
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
 
 public class ServletSmistamento extends HttpServlet
 {
    
   /*
	* il metodo gestisce le richieste di tipo get tramite l'uso dell'header <br>
	* redirect --- primo esempio dell'articolo<br>
	*/
/*	public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
		//non ho bisogno di un oggetto PrintWriter o ServletOutputStream, perch questa servlet non risponde      //direttamente al browser

		//imposto content-type della risposta
		response.setContentType("text/html");
		String url = "";
		//controllo i parametri nella Query String
		String nomeP = request.getParameter(NamePars.op()) == null?"":request.getParameter(NamePars.op());
		if(nomeP.equals(ValPars.cat()))
		{
			//passo alla nuova servlet tutta la Query String, anche se potrei usare il metodo
			//parseQueryString() per eliminare il parametro  'operazione'. 
			//Comunque questo non provoca problemi
			//NOTARE CHE LA URL E' ASSOLUTA
			getServletContext().log("sto qui ");
			url  = "http://localhost:8080/cd/servlet/ServletCatalogo";//+"?"+request.getQueryString();
						getServletContext().log("sto qui 2");
			//Imposto il campo Location
			response.setHeader("Location", url);
			//imposto lo status: 302 corrisponde a "MOVED_ TEMPORARILY" (con 301, //"MOVED_PERMANENTLY", la prossima volta che il browser dovr  chiamare quella stessa  //locazione, la cercher nella nuova URI
			response.setStatus(302);
			//tutto il codice che segue verr comunque eseguito
		}
		else if(nomeP.equals(ValPars.ord()))
		{
			url  = "http://localhost:8080/cd/servlet/ServletOrdini"+"?"+request.getQueryString();
			getServletContext().log("url = "+url);
			response.setHeader("Location", url);
			response.setStatus(302);

		}
		else
		{
		    url  = "http://localhost:8080/cd/index.htm";
			response.setHeader("Location", url);
			response.setStatus(302);
		}

	}*/
	
    
	/*
	* il metodo gestisce le richieste di tipo get tramite l'uso di<br>
	* sendRedirect --- secondo esempio dell'articolo<br>
	*/
	/*public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
	//imposto content-type della risposta
	response.setContentType("text/html");
	String url = "";
	 String nomeP = request.getParameter(NamePars.op()) == null?"":request.getParameter(NamePars.op());  
	    if(nomeP.equals(ValPars.cat()))
	    {
	        //NOTARE CHE LA URL E' ASSOLUTA
	        url  = "http://localhost:8080/cd/servlet/ServletCatalogo?"+request.getQueryString();   
	        //chiamo sendRedirect passandogli la nuova URI, con la Query String 
	         response.sendRedirect(url);
	    }
	    else if(nomeP.equals(ValPars.ord()))
	    {
	         url  = "http://localhost:8080/cd/servlet/ServletOrdini?"+request.getQueryString();
	         response.sendRedirect(url);
	    }
		else
		{
		    url  = "http://localhost:8080/cd/index.htm";
			response.sendRedirect(url);
		}
	}*/

 

   /*
	*  il metodo gestisce le richieste di tipo get tramite l'uso di<br>
	*  sendRedirect --- terzo esempio dell'articolo<br>
	*/
    /*public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
	//istanzio l'output stream per la risposta
	PrintWriter out  =  response.getWriter();

	//imposto content-type della risposta
	response.setContentType("text/html");
	String url = "";
	String nomeP = request.getParameter(NamePars.op()) == null?"":request.getParameter(NamePars.op());
	//controllo i parametri nella Query String
	    if(nomeP.equals(ValPars.cat()))
	    {
	         url  = "http://localhost:8080/cd/servlet/ServletCatalogo?"+request.getQueryString();
	         response.setContentType("text/html");  
	        //chiamo sendRedirect passandogli la nuova URI, con la Query String 
	         response.sendRedirect(url);
	    }
	    else if(nomeP.equals(ValPars.ord()))
	    {
	         url  = "http://localhost:8080/cd/servlet/ServletOrdini"+"?"+request.getQueryString();
	         response.sendRedirect(url);   
	    }
		else
		{
		  url  = "http://localhost:8080/cd/index.htm";
	         response.sendRedirect(url);   
		}
	   //spedisco una pagina al client
	   out.println("<html> <title>Questa Pagina  potenzialmente dannosa!</title>");
	   out.println("<body><H2>Probabilmente non vedrai questa scritta\n");
	   out.println("anzi potresti vedere una pagina molto strana</H></body></html>");
	   out.close();

	}*/

   
   /*
	*	il metodo gestisce le richieste di tipo get tramite l'uso di<br>
	*	sendRedirect --- quarto esempio dell'articolo.<br>
	*	Questo esempio non funziona,  solo indicativo, perch non visualizza<br>
	*	mai il file index.htm
	*/	
    /*public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
	//predispongo l'output stream per la risposta
	PrintWriter out  =  null;
	String url = "";
    String nomeP = request.getParameter(NamePars.op()) == null?"":request.getParameter(NamePars.op());
	    if(nomeP.equals(ValPars.cat()))
	    {
	         url  = "http://localhost:8080/cd/servlet/ServletCatalogo"+"?"+request.getQueryString();
	         response.setContentType("text/html");  
	        //chiamo sendRedirect passandogli la nuova URI, con la Query String 
	         response.sendRedirect(url);
	    }
	    else if(nomeP.equals(ValPars.ord()))
	    {
	         url  = "http://localhost:8080/cd/servlet/ServletOrdini"+"?"+request.getQueryString();
	         response.sendRedirect(url);     
	    }
	    else
	    { 
		    //istanzio l'oggetto Writer
		     out = response.getWriter(); 
		  	//spedisco una pagina al client
		   	out.println("<html> <title>Questa Pagina  potenzialmente dannosa!</title>");
			out.println("<body><H2>Probabilmente non vedrai questa scritta\n");
		    out.println("anzi potresti vedere una pagina molto strana</H></body></html>");
		    out.close();
	    }
	}*/
	
	
	
	

    /*
	* il metodo gestisce le richieste di tipo get tramite l'uso di<br>
	* forward() --- quinto esempio dell'articolo<br>
	*/
	public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
	//istanzio l'output stream per la risposta
	PrintWriter out  =  response.getWriter();

	//imposto content-type della risposta
	response.setContentType("text/html");
	String url = "";
	String nomeP = request.getParameter(NamePars.op()) == null?"":request.getParameter(NamePars.op());
	//controllo i parametri nella Query String
	    if(nomeP.equals(ValPars.cat()))
	    {
	        //NOTARE CHE LA URL E' RELATIVA
	         url  = "/servlet/ServletCatalogo?"+request.getQueryString();
	         
	          //Ora spedisco una pagina al client come avevo fatto nell'esempio precedente
	          out.println("<html> ");
	          out.println("<title>Questa Pagina  sicuramente inutile</title>");
	          out.println("<body><H2>Sicuramente non vedrai questa scritta</H>");
	          out.println("Perch il mio buffer di output verr cancellato!");
	          out.println("</body>");
	          out.println("</html>");
	      
	         //ottengo l'oggetto RequestDispatcher
	          RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url); 
	          //chiamo forward passandogli l'oggetto request e l'oggetto response
	          dispatcher.forward(request, response);
	    }
	    else if(nomeP.equals(ValPars.ord()))
	    {
	         url  = "/servlet/ServletOrdini?"+request.getQueryString();
	         RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url); 
	         
	         dispatcher.forward(request, response);
	         
	          //Provo ancora una volta a spedire  una pagina al client
	          out.println("<html> ");
	          out.println("<title>Anche questa Pagina  inutile</title>");
	          out.println("<body><H2>Sicuramente non vedrai questa scritta</H2>");
	          out.println("Perch non posso scrivere sul buffer di output!");
	          out.println("</body>");
	          out.println("</html>");
	          out.close();
	    }
		else
		{
		    url  = "/index.htm";
	         RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url); 
	         dispatcher.forward(request, response);
		}
	 
	}

	
	
	 /*
	* il metodo gestisce le richieste di tipo get tramite l'uso di<br>
	* forward(), scatenando un'eccezione illegalState --- sesto esempio dell'articolo<br>
	*/
	/*public void doGet(HttpServletRequest request, HttpServletResponse response)
  	throws ServletException, IOException
	{
	//istanzio l'output stream per la risposta
	PrintWriter out  =  response.getWriter();

	//imposto content-type della risposta
	response.setContentType("text/html");
	String url = "";
	   //Ora spedisco una pagina al client come avevo fatto nell'esempio precedente
	   out.println("<html> <title>Questa Pagina  sicuramente inutile</title>");
	   out.println("<body><H2>Sicuramente non vedrai questa scritta</H></body></html>");
	   out.flushBuffer();
	   //questa chiamata provocher un'eccezione di tipo IllegalStateException: catturiamola
	    try
	    {
	        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url); 
	 dispatcher.forward(request, response);
	    }
	    catch(IllegalStateException ise)
	    {
	            //l'unica cosa che vedr  sar la stack trace dell'eccezione
	            ise.printStackTrace(out);
	    }
	}*/

 
 
 }
