import java.util.*;
import java.io.*;
public class Order implements java.io.Serializable
{
	private String codice = "";
	private String titolo = "";
	private String autore = "";
	private String prezzo = "";
	
	private Vector vItems = null;
	
	
	public Order()
	{
	}
	
	
	/*
	*	imposta un nuovo valore del bean.<br>
	*	se il il vettore di oridini  vuoto, lo crea.<br>
	*	@param	String item  il nuovo ordine
	*/
	public void setOrder(String item) throws IOException
	{
	  boolean duplicato = false;
	  if (vItems == null)
	  {
	  	vItems = new Vector();	
	  }
	  
	  for(int i = 0;i < vItems.size(); i++)
	  {
	    if (vItems.get(i).equals(item))
		{
		   duplicato = true;
		   break;
		}
	  }
	  if(!duplicato)
	  vItems.add(item);
	  duplicato = false; 
	}
    
	
	
	/*
	*	rimuove dal vettore di ordini l'elemento indicato
	*/
	public void removeOrder(String item)
	{
	  for(int i = 0;i < vItems.size(); i++)
	  {
	  	if (vItems.elementAt(i).equals(item))
		{
		   vItems.remove(i);
		}
	  }
	}
	
	
	/*
	*	restituisce, sebbene in maniera forzata,i titoli corrispondenti<br>
	*	ai codici contenuti nel vettore di ordini.<br>
	*
	*	@params		Catalogo un oggetto che contiene il catalogo letto da file
	*	@return		Vector un vettore di appoggio contenente i titoli
	*/
	public Vector getOrder()
	{ 
	  return vItems;
	}
}
